// CSEE 4840 Bettor Sports Arbitrage Iterator Module

module iterator(
	input logic clk,
    input logic reset,
    input logic start,
    input logic found_result,
    input logic flushed,
    input logic [7:0] even_index_end,
    input logic [7:0] odd_index_end,

	output logic [7:0] even_index,
    output logic [7:0] odd_index,
    output logic running,
	output logic done
);

    logic wait_one_cycle;
    initial begin
        even_index = 0;
        odd_index = 1;
        running = 0;
        wait_one_cycle = 0;
    end

    assign done = even_index + 2 > even_index_end;

	always_ff@(posedge clk) begin
		if (reset) begin
            running <= 0;
		end

        if (start) begin
            running <= 1;
            even_index <= 0;
			odd_index <= 1;
            wait_one_cycle <= 0;
        end

        wait_one_cycle <= !wait_one_cycle;

		if(running && !reset && !done && !wait_one_cycle) begin
            if (!found_result || flushed) begin
                if(odd_index + 2 >= odd_index_end) begin
                    odd_index <= 1;
                    even_index <= even_index + 2;
                    if (even_index + 2 == even_index_end) running <= 0;
                end else begin
                    odd_index <= odd_index + 2;
                end
            end
		end
    end
endmodule

