module twoport_memory(
    input logic         clk,
    input logic [7:0]   a1, a2,
    input logic         write1, write2,
    input logic [31:0]  writedata1, writedata2,
    output logic [31:0] readdata1, readdata2
);

    logic [31:0] mem [255:0];

    always_ff @(posedge clk) begin
        if (write1) begin
            mem[a1] <= writedata1;
            readdata1 <= writedata1;
        end else readdata1 <= mem[a1];
    end

    always_ff @(posedge clk) begin
        if (write2) begin
            mem[a2] <= writedata2;
            readdata2 <= writedata2;
        end else readdata2 <= mem[a2];
    end
endmodule

