#ifndef _ARB_H
#define _ARB_H

#define OC_IS_A(event) (!(event)->outcome)
#define OC_IS_B(event) ((event)->outcome)

typedef struct {
	uint32_t odds:		20;	// 19:0
	uint32_t game_id:	4;	// 23:20
	uint32_t bookie_id: 4;	// 27:24
	uint32_t outcome:	1;	// 28
	uint32_t unused:	3;	// 31:29
} arb_event_t;

typedef struct {
	uint32_t arb_prob:		20;	// 19:0
	uint32_t game_id:		4;	// 23:20
	uint32_t bookie_id_a:	4;	// 27:24
	uint32_t bookie_id_b:	4;	// 31:28
} arb_result_t;

static void init_event(arb_event_t *event, uint32_t odds, uint32_t game_id, uint32_t bookie_id, uint32_t outcome)
{
	event->odds = odds;
	event->game_id = game_id;
	event->bookie_id = bookie_id;
	event->outcome = outcome;
}

static void init_arb(arb_result_t *arb, uint32_t arb_prob, uint32_t game_id, uint32_t bookie_id_a, uint32_t bookie_id_b)
{
	arb->arb_prob = arb_prob;
	arb->game_id = game_id;
	arb->bookie_id_a = bookie_id_a;
	arb->bookie_id_b = bookie_id_b;
}

#endif
