#ifndef _FIXED_POINT_H
#define _FIXED_POINT_H

#include <math.h>
#include <stdint.h>
#include <stdlib.h>

#define FIXED_POINT_MAX 1024
#define FIXED_POINT_FRACTIONAL_BITS 10

#define IS_ARB(a, b)((((a) + (b)) << FIXED_POINT_FRACTIONAL_BITS) < ((a) * (b)))
#define PROFIT(a, b, i)((((a) * (b) * (i)) / ((a) + (b))) - (i))

typedef uint32_t fixed_point_t;

static inline fixed_point_t double_to_fixed(double input)
{
	return (fixed_point_t)(round(input * (1 << FIXED_POINT_FRACTIONAL_BITS)));
}

static inline double fixed_to_double(fixed_point_t input)
{
    return ((double)input / (double)(1 << FIXED_POINT_FRACTIONAL_BITS));
}

#endif
