#include <iostream>
#include "Vbettor_arb.h"
#include <verilated.h>
#include <verilated_vcd_c.h>
#include <cassert>

static void update_clk(Vbettor_arb& bettorSim, VerilatedVcdC& tfp, int time)
{
	bettorSim.clk = (time % 20) >= 10;
	bettorSim.eval();
	tfp.dump( time );
}

void simulate_bettor_arb(Vbettor_arb& bettorSim, VerilatedVcdC& tfp)
{
    int time = 0;
    
    for ( ; time < 300000; time += 10) {
        update_clk(bettorSim, tfp, time);
    }

    update_clk(bettorSim, tfp, time);
}

int main(int argc, const char ** argv, const char ** env) {
    Verilated::commandArgs(argc, argv);
    Vbettor_arb bettorSim;
    Verilated::traceEverOn(true);
    VerilatedVcdC tfp;
    bettorSim.trace(&tfp, 99);
    tfp.open("bettor_arb.vcd");

    simulate_bettor_arb(bettorSim, tfp);

    tfp.close();
    bettorSim.final();

    return 0;
}